/*
 * generated by Xtext 2.21.0
 */
package br.ufes.nemo.seon.ontoloyasservice.ide.contentassist.antlr;

import br.ufes.nemo.seon.ontoloyasservice.ide.contentassist.antlr.internal.InternalOaasParser;
import br.ufes.nemo.seon.ontoloyasservice.services.OaasGrammarAccess;
import com.google.common.collect.ImmutableMap;
import com.google.inject.Inject;
import com.google.inject.Singleton;
import java.util.Map;
import org.eclipse.xtext.AbstractElement;
import org.eclipse.xtext.ide.editor.contentassist.antlr.AbstractContentAssistParser;

public class OaasParser extends AbstractContentAssistParser {

	@Singleton
	public static final class NameMappings {
		
		private final Map<AbstractElement, String> mappings;
		
		@Inject
		public NameMappings(OaasGrammarAccess grammarAccess) {
			ImmutableMap.Builder<AbstractElement, String> builder = ImmutableMap.builder();
			init(builder, grammarAccess);
			this.mappings = builder.build();
		}
		
		public String getRuleName(AbstractElement element) {
			return mappings.get(element);
		}
		
		private static void init(ImmutableMap.Builder<AbstractElement, String> builder, OaasGrammarAccess grammarAccess) {
			builder.put(grammarAccess.getAbstractElementAccess().getAlternatives(), "rule__AbstractElement__Alternatives");
			builder.put(grammarAccess.getRelationAccess().getAlternatives(), "rule__Relation__Alternatives");
			builder.put(grammarAccess.getApplicationAccess().getGroup(), "rule__Application__Group__0");
			builder.put(grammarAccess.getConfigurationAccess().getGroup(), "rule__Configuration__Group__0");
			builder.put(grammarAccess.getOntologyAccess().getGroup(), "rule__Ontology__Group__0");
			builder.put(grammarAccess.getLevelAccess().getGroup(), "rule__Level__Group__0");
			builder.put(grammarAccess.getAuthorAccess().getGroup(), "rule__Author__Group__0");
			builder.put(grammarAccess.getAuthor_EmailAccess().getGroup(), "rule__Author_Email__Group__0");
			builder.put(grammarAccess.getRepositoryAccess().getGroup(), "rule__Repository__Group__0");
			builder.put(grammarAccess.getOntologyShortNameAccess().getGroup(), "rule__OntologyShortName__Group__0");
			builder.put(grammarAccess.getSoftwareAccess().getGroup(), "rule__Software__Group__0");
			builder.put(grammarAccess.getAboutAccess().getGroup(), "rule__About__Group__0");
			builder.put(grammarAccess.getDescriptionAccess().getGroup(), "rule__Description__Group__0");
			builder.put(grammarAccess.getEntity_TypeAccess().getGroup(), "rule__Entity_Type__Group__0");
			builder.put(grammarAccess.getModuleAccess().getGroup(), "rule__Module__Group__0");
			builder.put(grammarAccess.getQualifiedNameAccess().getGroup(), "rule__QualifiedName__Group__0");
			builder.put(grammarAccess.getQualifiedNameAccess().getGroup_1(), "rule__QualifiedName__Group_1__0");
			builder.put(grammarAccess.getImportAccess().getGroup(), "rule__Import__Group__0");
			builder.put(grammarAccess.getQualifiedNameWithWildcardAccess().getGroup(), "rule__QualifiedNameWithWildcard__Group__0");
			builder.put(grammarAccess.getEntityAccess().getGroup(), "rule__Entity__Group__0");
			builder.put(grammarAccess.getEntityAccess().getGroup_3(), "rule__Entity__Group_3__0");
			builder.put(grammarAccess.getAttributeAccess().getGroup(), "rule__Attribute__Group__0");
			builder.put(grammarAccess.getOneToOneAccess().getGroup(), "rule__OneToOne__Group__0");
			builder.put(grammarAccess.getManyToManyAccess().getGroup(), "rule__ManyToMany__Group__0");
			builder.put(grammarAccess.getOneToManyAccess().getGroup(), "rule__OneToMany__Group__0");
			builder.put(grammarAccess.getFunctionAccess().getGroup(), "rule__Function__Group__0");
			builder.put(grammarAccess.getFunctionAccess().getGroup_4(), "rule__Function__Group_4__0");
			builder.put(grammarAccess.getFunctionAccess().getGroup_4_1(), "rule__Function__Group_4_1__0");
			builder.put(grammarAccess.getApplicationAccess().getConfigurationAssignment_0(), "rule__Application__ConfigurationAssignment_0");
			builder.put(grammarAccess.getApplicationAccess().getAbstractElementsAssignment_1(), "rule__Application__AbstractElementsAssignment_1");
			builder.put(grammarAccess.getConfigurationAccess().getOntologyAssignment_2(), "rule__Configuration__OntologyAssignment_2");
			builder.put(grammarAccess.getConfigurationAccess().getOntologyShortNameAssignment_3(), "rule__Configuration__OntologyShortNameAssignment_3");
			builder.put(grammarAccess.getConfigurationAccess().getLevelAssignment_4(), "rule__Configuration__LevelAssignment_4");
			builder.put(grammarAccess.getConfigurationAccess().getAboutAssignment_5(), "rule__Configuration__AboutAssignment_5");
			builder.put(grammarAccess.getConfigurationAccess().getSoftwareAssignment_6(), "rule__Configuration__SoftwareAssignment_6");
			builder.put(grammarAccess.getConfigurationAccess().getAuthorAssignment_7(), "rule__Configuration__AuthorAssignment_7");
			builder.put(grammarAccess.getConfigurationAccess().getAuthor_emailAssignment_8(), "rule__Configuration__Author_emailAssignment_8");
			builder.put(grammarAccess.getConfigurationAccess().getRepositoryAssignment_9(), "rule__Configuration__RepositoryAssignment_9");
			builder.put(grammarAccess.getOntologyAccess().getNameAssignment_1(), "rule__Ontology__NameAssignment_1");
			builder.put(grammarAccess.getLevelAccess().getNameAssignment_1(), "rule__Level__NameAssignment_1");
			builder.put(grammarAccess.getAuthorAccess().getNameAssignment_1(), "rule__Author__NameAssignment_1");
			builder.put(grammarAccess.getAuthor_EmailAccess().getNameAssignment_1(), "rule__Author_Email__NameAssignment_1");
			builder.put(grammarAccess.getRepositoryAccess().getNameAssignment_1(), "rule__Repository__NameAssignment_1");
			builder.put(grammarAccess.getOntologyShortNameAccess().getNameAssignment_1(), "rule__OntologyShortName__NameAssignment_1");
			builder.put(grammarAccess.getSoftwareAccess().getNameAssignment_1(), "rule__Software__NameAssignment_1");
			builder.put(grammarAccess.getAboutAccess().getNameAssignment_1(), "rule__About__NameAssignment_1");
			builder.put(grammarAccess.getDescriptionAccess().getTextfieldAssignment_1(), "rule__Description__TextfieldAssignment_1");
			builder.put(grammarAccess.getEntity_TypeAccess().getNameAssignment_1(), "rule__Entity_Type__NameAssignment_1");
			builder.put(grammarAccess.getModuleAccess().getDescriptionAssignment_0(), "rule__Module__DescriptionAssignment_0");
			builder.put(grammarAccess.getModuleAccess().getNameAssignment_2(), "rule__Module__NameAssignment_2");
			builder.put(grammarAccess.getModuleAccess().getElementsAssignment_4(), "rule__Module__ElementsAssignment_4");
			builder.put(grammarAccess.getImportAccess().getImportedNamespaceAssignment_1(), "rule__Import__ImportedNamespaceAssignment_1");
			builder.put(grammarAccess.getEntityAccess().getDescriptionAssignment_0(), "rule__Entity__DescriptionAssignment_0");
			builder.put(grammarAccess.getEntityAccess().getNameAssignment_2(), "rule__Entity__NameAssignment_2");
			builder.put(grammarAccess.getEntityAccess().getSuperTypeAssignment_3_1(), "rule__Entity__SuperTypeAssignment_3_1");
			builder.put(grammarAccess.getEntityAccess().getEntity_typeAssignment_5(), "rule__Entity__Entity_typeAssignment_5");
			builder.put(grammarAccess.getEntityAccess().getAttributesAssignment_6(), "rule__Entity__AttributesAssignment_6");
			builder.put(grammarAccess.getEntityAccess().getFunctionsAssignment_7(), "rule__Entity__FunctionsAssignment_7");
			builder.put(grammarAccess.getEntityAccess().getRelationsAssignment_8(), "rule__Entity__RelationsAssignment_8");
			builder.put(grammarAccess.getAttributeAccess().getDescriptionAssignment_0(), "rule__Attribute__DescriptionAssignment_0");
			builder.put(grammarAccess.getAttributeAccess().getNameAssignment_1(), "rule__Attribute__NameAssignment_1");
			builder.put(grammarAccess.getAttributeAccess().getTypeAssignment_3(), "rule__Attribute__TypeAssignment_3");
			builder.put(grammarAccess.getOneToOneAccess().getNameAssignment_0(), "rule__OneToOne__NameAssignment_0");
			builder.put(grammarAccess.getOneToOneAccess().getTypeAssignment_2(), "rule__OneToOne__TypeAssignment_2");
			builder.put(grammarAccess.getManyToManyAccess().getNameAssignment_0(), "rule__ManyToMany__NameAssignment_0");
			builder.put(grammarAccess.getManyToManyAccess().getTypeAssignment_2(), "rule__ManyToMany__TypeAssignment_2");
			builder.put(grammarAccess.getOneToManyAccess().getNameAssignment_0(), "rule__OneToMany__NameAssignment_0");
			builder.put(grammarAccess.getOneToManyAccess().getTypeAssignment_2(), "rule__OneToMany__TypeAssignment_2");
			builder.put(grammarAccess.getFunctionAccess().getDescriptionAssignment_0(), "rule__Function__DescriptionAssignment_0");
			builder.put(grammarAccess.getFunctionAccess().getNameAssignment_2(), "rule__Function__NameAssignment_2");
			builder.put(grammarAccess.getFunctionAccess().getParamsAssignment_4_0(), "rule__Function__ParamsAssignment_4_0");
			builder.put(grammarAccess.getFunctionAccess().getParamsAssignment_4_1_1(), "rule__Function__ParamsAssignment_4_1_1");
			builder.put(grammarAccess.getFunctionAccess().getTypeAssignment_7(), "rule__Function__TypeAssignment_7");
		}
	}
	
	@Inject
	private NameMappings nameMappings;

	@Inject
	private OaasGrammarAccess grammarAccess;

	@Override
	protected InternalOaasParser createParser() {
		InternalOaasParser result = new InternalOaasParser(null);
		result.setGrammarAccess(grammarAccess);
		return result;
	}

	@Override
	protected String getRuleName(AbstractElement element) {
		return nameMappings.getRuleName(element);
	}

	@Override
	protected String[] getInitialHiddenTokens() {
		return new String[] { "RULE_WS", "RULE_ML_COMMENT", "RULE_SL_COMMENT" };
	}

	public OaasGrammarAccess getGrammarAccess() {
		return this.grammarAccess;
	}

	public void setGrammarAccess(OaasGrammarAccess grammarAccess) {
		this.grammarAccess = grammarAccess;
	}
	
	public NameMappings getNameMappings() {
		return nameMappings;
	}
	
	public void setNameMappings(NameMappings nameMappings) {
		this.nameMappings = nameMappings;
	}
}
